<template>
<!-- Main content -->
<section class="content">

<div style="top-board-section">


  
  <div class="row" >
    <div class="col-md-4 col-sm-6 col-sm-12">
      <h3 class="page-header">
        Welcome to Demo Project
      <nav aria-label="breadcrumb" >
        <ol class="breadcrumb" >
          <li class="breadcrumb-item">
            <a href="/dashbord">
            Demo Project 
            </a>
          </li>
        </ol>
      </nav>
      </h3>
        
    </div>
    <!-- <div class="clearfix visible-sm-block"></div>

    <div class="col-md-2 col-sm-6 col-xs-12">
      <process-info-box color-class="bg-white" :icon-classes="['fa', 'fa fa-building']" text="कुल घरधुरी" :number="totalHouse">
      </process-info-box>
    </div>
    <div class="col-md-2 col-sm-6 col-xs-12">
      <process-info-box class="purchase" color-class="bg-white" :icon-classes="['fa', 'fa fa-users']" text="कुल जनसंख्या" :number="totalPopulation"></process-info-box>
    </div>
    <div class="col-md-2 col-sm-6 col-xs-12">
      <process-info-box class="cashIn" color-class="bg-white" :icon-classes="['fa', 'fa fa-male']" text="पुरुष संख्या" :number="totalMale"></process-info-box>
    </div>
    <div class="col-md-2 col-sm-6 col-xs-12">
      <process-info-box class="female" color-class="bg-white" :icon-classes="['fa', 'fa fa-female']" text="महिला संख्या" :number="totalFemale"></process-info-box>
    </div>
  </div>
</div>


 <googleMap ref="googleMap"/>
 <br/>
  <br/>

  <div class="p-fluid p-formgrid p-grid" >
    <div class="p-field p-col-12 p-md-6">
      <Chart type="bar" :data="basicData" />
    </div>
     <div class="p-field p-col-12 p-md-6">
      <DataTable ref="po"
      :value="genderWiseReportLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
       <template #header>
        लिङ्गका आधारमा जनसंख्याको विवरण
    </template>
      <Column header="प्रशासनिक क्षेत्र" field="wardName" :sortable="true">
      </Column>

      <Column header="पुरुष संख्या" :sortable="true" field="totalMale" filterMatchMode="contains">
              </Column> 

        <Column header="महिला संख्या" :sortable="true" field="totalFemale" filterMatchMode="contains">
              </Column> 

          <Column header="अन्य​ संख्या" :sortable="true" field="totalOther" filterMatchMode="contains">
              </Column> 

      <Column header="जम्मा" :sortable="true" field="total" filterMatchMode="contains">
              </Column> 
    </DataTable>
    </div>
  </div>

    <div class="p-fluid p-formgrid p-grid" >
          <div class="p-field p-col-12 p-md-3">
      <DataTable ref="po"
      :value="customerLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
       <template #header>
        बजेट वितरण
    </template>
      <Column header="Name" :sortable="true">
      </Column>

      <Column header="Percentage" :sortable="true" field="fullName" filterMatchMode="contains">
              </Column>  
    </DataTable>
    </div>
    <div class="p-field p-col-12 p-md-3">
      <DataTable ref="po"
      :value="customerLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
       <template #header>
        बिकास सुचक
    </template>
      <Column header="Name" >
      </Column>

      <Column header="Percentage" :sortable="true" field="fullName" filterMatchMode="contains">
              </Column>  
    </DataTable>
    </div>
     <div class="p-field p-col-12 p-md-6">
      <DataTable ref="po"
      :value="languageWiseReportLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
      <template #header>
        मातृभाषाको आधारमा जनसंख्याको विवरण
    </template>
      <Column header="नेपाली" filterMatchMode="contains" field="nepali" :sortable="true">
      </Column>

      <Column header="पमैथिली" :sortable="true" field="maithali" filterMatchMode="contains">
              </Column> 

        <Column header="थारु" :sortable="true" field="tharu" filterMatchMode="contains">
              </Column> 

          <Column header="नेवारी" :sortable="true" field="newari" filterMatchMode="contains">
              </Column> 

      <Column header="मगर" :sortable="true" field="magar" filterMatchMode="contains">
              </Column> 
              <Column header="लिम्बु" :sortable="true" field="limbu" filterMatchMode="contains">
  
              </Column> 
              <Column header="राई" :sortable="true" field="rai" filterMatchMode="contains">
              </Column> 
               <Column header="हिन्दी" :sortable="true" field="hindi" filterMatchMode="contains">
  
              </Column> 
               <Column header="अन्य" :sortable="true" field="other" filterMatchMode="contains">
              </Column> 
    </DataTable>
    </div>
      <div class="p-field p-col-12 p-md-6">
      <DataTable ref="po"
      :value="customerLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
       <template #header>
        ETHNICITY
    </template>
      <Column header="ADHIBASI JANAJATI" :sortable="true">
      </Column>

      <Column header="KHAS ARYA" :sortable="true" field="fullName" filterMatchMode="contains">
              </Column> 

        <Column header="DALIT" :sortable="true" field="contactNumber" filterMatchMode="contains">
              </Column> 

          <Column header="OTHERS" :sortable="true" field="gender" filterMatchMode="contains">
              </Column> 
    </DataTable>
    </div>

     <div class="p-field p-col-12 p-md-6">
      <DataTable ref="po"
      :value="customerLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
       <template #header>
        EDUCATION INSTITUITIONS
    </template>
      <Column header="Name" :sortable="true">
      </Column>

      <Column header="NO. INSTITUTIONS" :sortable="true" field="fullName" filterMatchMode="contains">
              </Column> 

        <Column header="TOTAL ENROLLMENT" :sortable="true" field="contactNumber" filterMatchMode="contains">
              </Column> 
    </DataTable>
    </div>
     <div class="p-field p-col-12 p-md-6">
      <DataTable ref="po"
      :value="customerLists"
      editMode="cell"
      :paginator="false"
      :rows="100"  :filters="filters"
      class="p-datatable-responsive-demo">
       <template #header>
        HEALTH INSTITUITIONS
    </template>
      <Column header="Name" :sortable="true">
      </Column>

      <Column header="NO. OF HOSPITALS" :sortable="true" field="fullName" filterMatchMode="contains">
              </Column> 

        <Column header="IN PATIENTS" :sortable="true" field="contactNumber" filterMatchMode="contains">
              </Column> 

          <Column header="OUT PATIENTS" :sortable="true" field="gender" filterMatchMode="contains">
              </Column> 
    </DataTable>
    </div> 
    -->
  </div>
    </div>

</section>
</template>

<script>
import InfoBox from '../widgets/InfoBox'
import ProcessInfoBox from '../widgets/ProcessInfoBox'
import Chart from 'primevue/chart'
import DataTable from 'primevue/datatable'
import Column from 'primevue/column'
import InputText from 'primevue/inputtext'
import Button from 'primevue/button'
import globalKey from '../../store/globalKey'
import axios from 'axios'
// import GoogleMap from '../views/customer/GoogleMap.vue'
export default {
  name: 'Dashboard',
  components: {
    InfoBox,
    ProcessInfoBox,
    customerLists: [],
    Chart,
    // GoogleMap,
    DataTable,
    Column,
    InputText,
    Button
  },
  data() {
    return {
      filters: {},
      totalSales: '',
      totalHouse: 0,
      totalMale: 0,
      totalFemale: 0,
      totalPopulation: 0,
      totalCashOut: '',
      totalAccountReceivable: '',
      totalAccountPayable: '',
      totalCashInHand: '',
      totalBankBalance: '',
      deliveredAmount: 0.0,
      delivered: 0,
      deliveredCharge: 0.0,
      cancelledAmount: 0.0,
      cancelled: 0,
      returnedOrdersAmount: 0.0,
      payableAmount: 0.0,
      unPaidAmount: 0.0,
      returned: 0,
      processingAmount: 0.0,
      processing: 0,
      basicData: {}
    }
  },
  computed: {
    soilAnalysisResultLists() {
      return this.$store.state.soilAnalysisResult.soilAnalysisResultLists
    },
    genderWiseReportLists() {
      return this.$store.state.report.genderWiseReportLists
    },
    languageWiseReportLists() {
      return this.$store.state.report.languageWiseReportLists
    }
  },
  mounted() {
    // debugger
    this.soilAnalysisResultList()
    this.genderWiseReportList()
    this.languageWiseReportList()
    this.totalCounts()
    this.reportGenderWiseList()
  },
  methods: {
    async soilAnalysisResultList() {
      try {
        await this.$store.dispatch('loadSoilAnalysisResultByCustomer')
      } catch (e) {}
    },
    async genderWiseReportList() {
      try {
        await this.$store.dispatch('loadDashGenderReport')
      } catch (e) {}
    },
    async languageWiseReportList() {
      try {
        await this.$store.dispatch('loadDashLanguageReport')
      } catch (e) {}
    },
    async reportGenderWiseList() {
      let resp = await this.$store.dispatch('loadDashGenderWiseResult')
      this.basicData = resp.data.data[0]
    },
    async totalCounts() {
      let response = await this.$store.dispatch('loadTotalCounts')
      response.data.data.forEach(data => {
        if (data.name === 'kulGharDhuri') {
          this.totalHouse = data.value
        } else if (data.name === 'population') {
          this.totalPopulation = data.value
        } else if (data.name === 'male') {
          this.totalMale = data.value
        } else if (data.name === 'female') {
          this.totalFemale = data.value
        }
      })
    },
    exportCSV() {
      let data = {
        columnList: this.columnList,
        toDate: this.$store.getters.nepaliNewDate,
        fromDate: this.$store.getters.nepaliNewDate
      }
      axios({
        url: globalKey + '/fileDownload/excelReport' + '/' + this.$store.getters.userId + '/' + data.fromDate + '/' + data.toDate + '/' + 'SoilAnalysisCustomer' + '/' + this.$store.getters.fyId + '/' + data.columnList,
        method: 'get',
        headers: { 'Accept': 'application/vnd.ms-excel', 'Authorization': localStorage.token },
        responseType: 'blob'
      }).then((response) => {
        const url = window.URL.createObjectURL(new Blob([response.data]), {type: response.data.type})
        const link = document.createElement('a')
        const contentDisposition = response.headers['content-disposition']
        let fileName = 'soilAnalysisReportCustomer.xlsx'
        if (contentDisposition) {
          const fileNameMatch = contentDisposition.match(/filename="(.+)"/)
          if (fileNameMatch.length === 2) {
            fileName = fileNameMatch[1]
          }
        }
        link.href = url
        link.setAttribute('download', fileName)
        document.body.appendChild(link)
        link.click()
        link.remove()
        window.URL.revokeObjectURL(url)
      })
    }
  }
}
</script>
<style>
.info-box {
  cursor: pointer;
}

.info-box-content {
  text-align: center;
  vertical-align: middle;
  display: inherit;
}
.purchase{
  color:#e23e3e;
}
.cashIn{
  color: #3f8d2b;
}
.female{
  color: rgb(252, 30, 252);
}
.fullCanvas {
  width: 100%;
}
.tb {
  padding: 0.571em 0.857em;
  border: 1px solid #ffffff;
  font-weight: 700;
  color: #333333;
  background-color: #ffffff;
  text-align: center;
}
</style>
